from arr2_epec_seg_ex import *


def count(rec: Polygon_2, P: Polygon_2, placements) -> int:
    transformed_polygons = []
    for placement in placements:
        x = placement[0]
        y = placement[1]
        sin_a = placement[3]
        cos_a = placement[2]
        assert (sin_a * sin_a + cos_a * cos_a == FT(1))
        rt = Aff_transformation_2(Rotation(), sin_a, cos_a, FT(1))
        tt = Aff_transformation_2(Translation(), Vector_2(x, y))
        transformed_polygon = [rt.transform(p) for p in P.vertices()]
        transformed_polygon = [tt.transform(p) for p in transformed_polygon]
        transformed_polygons.append(Polygon_2(transformed_polygon))

    # Naively check every pair of two polygons for intersection
    for i in range(len(transformed_polygons)):
        for j in range(i + 1, len(transformed_polygons)):
            P1: Polygon_2 = transformed_polygons[i]
            P2: Polygon_2 = transformed_polygons[j]
            if do_intersect(P1, P2): return -1

    # Check that every polygon is contained inside the bounding rectangle
    Poly: Polygon_2
    for Poly in transformed_polygons:
        if Poly.left_vertex().x() < rec.vertex(0).x(): return -1
        if Poly.right_vertex().x() > rec.vertex(1).x(): return -1
        if Poly.top_vertex().y() > rec.vertex(2).y(): return -1
        if Poly.bottom_vertex().y() < rec.vertex(0).y(): return -1

    return len(transformed_polygons)
